import {
  Controller,
  Get,
  Res,
  Header,
  Post,
  Body,
  Request, Param, ParseUUIDPipe,
} from '@nestjs/common';
import { Response } from 'express';
import { TransactionService } from './transaction.service';
import { ExportTransactionDto } from './dto/export-transaction.dto';

@Controller({
  path: 'excel',
  version: '1',
})
export class ExcelController {
  constructor(private transactionService: TransactionService) {}

  @Post('history-user/export/:id')
  @Header('Content-Type', 'text/xlsx')
  async exportTransactionHistory(
    @Param('id', ParseUUIDPipe) id: string,
    @Body() exportTransactionDto: ExportTransactionDto,
    @Request() req,
    @Res() res: Response,
  ) {
    res.set({
      'Content-Disposition': 'attachment; filename="package.xlsx"',
    });
    const result = await this.transactionService.exportDataExcel(
      exportTransactionDto.dateStart,
      id,
    );

    res.download(`${result}`);
  }
}
